package org.monaka.book.android.camera;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.PixelFormat;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.view.SurfaceHolder;

public class HanabiraListener implements SensorEventListener {
	private int x = 0;
	private int y = 0;
	private Paint paint = new Paint();
	private SurfaceHolder surfaceHolder;
	private Bitmap bitmap;

	public HanabiraListener(SurfaceHolder surfaceHolder, Bitmap bitmap) {
		this.surfaceHolder = surfaceHolder;
		this.bitmap = bitmap;
		surfaceHolder.setFormat(PixelFormat.TRANSPARENT);
	}

	@Override
	public void onAccuracyChanged(Sensor arg0, int arg1) {
	}

	@Override
	public void onSensorChanged(SensorEvent sensorEvent) {
		Canvas canvas;
		x += sensorEvent.values[0];
		y += sensorEvent.values[1];
		canvas =surfaceHolder.lockCanvas();
		canvas.drawBitmap(bitmap, x, y, paint);
		surfaceHolder.unlockCanvasAndPost(canvas);
	}

}
